(*** DATA TYPE DEFINITIONS **)

(* Supported SQL Column Types *)
type mltablecoltypes = INT | CHAR of int;;

(* Record to store a column definition *)
type mltablecoldef = {defcolname : string; coltype : mltablecoltypes};;

(* Variant type to store a value *)
type mltablecoldatavalue = Int of int 
                           | Char of string;;
                           
(* Record type to store a value for a given column in table *)                           
type mltablecoldata = {datacolname : string; value : mltablecoldatavalue};;

(* Record type to model a row in a table *)
type mltablerowdata = {data : mltablecoldata list};;

(* Record type to maintain a list of tables in dbms *)
type mltable = {tablename : string; coldeflist : mltablecoldef list; rowdatalist : mltablerowdata list};;

(* Record type to represent the entire database *)
type mldbms = { dbmsname : string; tablelist : mltable list};;  

(* Relational (comparison) operators *)
type relationalop = OpEq | OpNe ;;

(* Data Aggregation Types *)
type aggregationTypes = Avg | Sum;;

(* Predicate structure *)
type predicate = { preddata : mltablecoldata; predoper : relationalop };;

